#include <stdio.h>

#ifndef _TAPE_H
#define _TAPE_H

typedef struct tape {
    FILE *fp;
    int format;
    int state;
    int mstate;
    int hl;  /* high  / low  */
    long clock;

    int data;
    int nbit;
    int sl;  /* short / long */
    int send;
    int shortclk;
    int longclk;
    int size;
} TAPE;

#define RUNLENGTH 1
#define FILE2000B 2

TAPE *tropen(char *name);
TAPE *twopen(char *name,int format);
int tclose(TAPE *tp);

int tskip(TAPE *tp, long clock);
int tscan(TAPE *tp);

int twrite(TAPE *tp, int bit, long clock);

int tfile_type(char *filename);

#endif /* _TAPE_H */
