#include <stdio.h>
#include "../tape.h"

int error(char *argv);

int main(int argc, char **argv)
{
	TAPE *intp, *outtp;
	char *infile, *outfile;
	int format;
	char *formatstr;

	if (argc < 3) error(argv[0]);
	infile = argv[1];
	outfile = argv[2];

	formatstr = argv[0] + strlen(argv[0]) - 4;

	if (!strcmp(formatstr, "2mzf")) {
		format = TAPE_FILE2000B;
	} else if (!strcmp(formatstr, "2rlf")) {
		format = TAPE_RUNLENGTH;
	} else if (!strcmp(formatstr, "2bin")) {
		format = TAPE_DATA2000B;
	} else {
		fprintf(stderr, "%s: invalid program name\n", argv[0]);
		exit(1);
	}

	if ((intp = tropen(infile)) == NULL) {
		fprintf(stderr, "%s: Can't read file\n", infile);
		exit(1);
	}

	if ((outtp = twopen(outfile, format)) == NULL) {
		fprintf(stderr, "%s: Can't write file\n", outfile);
		exit(1);
	}

	tcopy(intp, outtp, 90);
	tclose(intp);
	tclose(outtp);
	return 0;
}

int error(char *argv)
{
	fprintf(stderr, "%s infile outfile\n", argv);
	exit(1);
}
