#include <stdio.h>
#include <stdlib.h>
#include "../tape.h"

int error(char *argv);

int main(int argc, char **argv)
{
	FILE *infp;
	TAPE *outtp;
	char *infile, *outfile;
	int i;
	int t = 0xa5;
	int format;
	char *formatstr;

	formatstr = argv[0] + strlen(argv[0]) - 4;

	if (!strcmp(formatstr, "2mzf")) {
		format = TAPE_FILE2000B;
	} else if (!strcmp(formatstr, "2rlf")) {
		format = TAPE_RUNLENGTH;
	} else if (!strcmp(formatstr, "2bin")) {
		format = TAPE_DATA2000B;
	} else {
		fprintf(stderr, "%s: invalid program name\n", argv[0]);
		exit(1);
	}

	for (i = 1; i < argc; i++) {
		if (argv[i][0] != '-') break;
		if (i == argc - 1) break;
		switch(argv[i][1]) {
		case 't':
			t = atoi(argv[++i]);
			break;
		default:
			error(argv[0]);
			break;
		}
	}

	if (argc <= i + 1) error(argv[0]);
	infile = argv[i];
	outfile = argv[i+1];

	if ((infp = fopen(infile, "r")) == NULL) {
		fprintf(stderr, "%s: Can't read file\n", infile);
		exit(1);
	}

	if ((outtp = twopen(outfile, format)) == NULL) {
		fprintf(stderr, "%s: Can't write file\n", outfile);
		exit(1);
	}

	do {
		unsigned char c;
		c = fgetc(infp);
		twrite(outtp, (c > t)? 1 : 0, 90);
	} while (!feof(infp));

	tclose(outtp);
	fclose(infp);
	return 0;
}

int error(char *argv)
{
	fprintf(stderr, "%s [-t threshold] infile outfile\n", argv);
	exit(1);
}
